; AIC26 sound output main framework

       .equ __30F6012, 1
        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f6012.inc"
;        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f6012.inc"
;		.include "DSPMacros.s"

;..............................................................................
        .global _wreg_init       ;Provide global scope to _wreg_init routine
                                 ;In order to call this routine from a C file,
                                 ;place "wreg_init" in an "extern" declaration
                                 ;in the C file.

        .global __reset          ;The label for the first line of code. 

 
;		.global	__PWMInterrupt
;..............................................................................
;Configuration bits:
;..............................................................................

        config __FOSC, CSW_FSCM_OFF & XT_PLL4    ;Turn off clock switching and
                                            ;fail-safe clock monitoring and
                                            ;use the External Clock as the
                                            ;system clock

        config __FWDT, WDTPSA_512 & WDT_OFF              ;Turn off Watchdog Timer

        config __FBORPOR, PBOR_ON & BORV_20 & PWRT_64 & MCLR_EN
                                            ;Set Brown-out Reset voltage and
                                            ;and set Power-up Timer to 64msecs

        config __FGS, CODE_PROT_OFF         ;Set Code Protection Off for the 

;.............................................................................
; Constants stored in Program space
;.............................................................................
;	 wavetable data
;.............................................................................
;		.section .asciitext, "x"
;		.palign 512 ;Align next word stored in
;SineTable:
;.include "sineTable.s"
;ExpTable:
;.include "expTable.s" 
;	.word	0x7FFF
;.............................................................................
; Unintialized storage in data space
;.............................................................................
         .section .xbss, "b"
dgdgdg:		.space 64
Osc1Pitch:				.space 2
Osc1Phasor:				.space 4
Osc1PhasorStep:			.space 4
Osc1Out:				.space 2

rng1:					.space 2

update:					.space 2
dither:					.space 2
count:					.space 2

Output:					.space 2

aAIC26x1:					.space 2
aAIC26x2:					.space 2
aAIC26x3:					.space 2
aAIC26x4:					.space 2
aAIC26x5:					.space 2
aAIC26x6:					.space 2
aAIC26x7:					.space 2
aAIC26x8:					.space 2


.text                             ;Start of Code section
__reset:
        MOV #__SP_init, W15       ;Initalize the Stack Pointer
        MOV #__SPLIM_init, W0     ;Initialize the Stack Pointer Limit Register
        MOV W0, SPLIM
        NOP                       ;Add NOP to follow SPLIM initialization
        
        CALL _wreg_init           ;Call _wreg_init subroutine
                                  ;Optionally use RCALL instead of CALL

		clr		Osc1Phasor;		LSB
		clr		Osc1Phasor+2;	MSB
		
		mov 	#0x4000,W0
		mov		W0,Osc1PhasorStep; LSB
		mov 	#0x0004,W0
		mov		W0,Osc1PhasorStep+2; MSB

		bset 	CORCON,#PSV ; Enable program space visibility

		clr		rng1
		bset 	rng1,#7
		mov		#0x1000,W0
		mov		W0,Osc1Pitch

		call	InitAIC26

loop:
;		btss	update,#1
		bra		loop

		bclr	update,#1
		
;		MTOF2	Osc1Pitch Osc1PhasorStep
;
;		PREPCOMPWAVETABLE1 SineTable
;		COMPWAVETABLE1 	Osc1PhasorStep SineTable Osc1Phasor Osc1Out
;		RNG16	rng1

		mov		Osc1Out,W4
		mov		#0x3000,W5
		mpy		W4*W5,A
		mov		ACCAH,W0
		mov 	W0,Output
		call	PutOutNonDithered

		inc		count
		mov		#0x1F,W0
		and		count
		bra		NZ,loop
		inc		Osc1Pitch

		bra loop


;---------------------------------------------------------------------------
;	PutOutNonDithered
;	
;	sure but boring
;---------------------------------------------------------------------------
PutOutNonDithered:
	return

InitAIC26:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	
		bset		 TRISB,#4

		clr 	_SPI2CON		

		bset	_SPI2CON,#FRMEN	;	framed mode?
		bclr	_SPI2CON,#SPIFSD	;	master
		bclr	_SPI2CON,#DISSDO ; 	no out disable
		bclr	_SPI2CON,#SMP 	; 	middle?
		bclr	_SPI2CON,#CKE	; 	valid at downward edge
		bset	_SPI2CON,#MODE16	; 	16 bit mode
		bset	_SPI2CON,#SSEN 	; 	slave select enable
		bclr	_SPI2CON,#CKP	;	clock polarity, 0 is idle
		bset	_SPI2CON,#MSTEN	;	master

		clr		_SPI2STAT
		bset	_SPI2STAT,#SPIEN	;	enable

		bclr	IFS1, #SPI2IF

		clr		aAIC26x1
		clr		aAIC26x2
		clr		aAIC26x3
		clr		aAIC26x4
		clr		aAIC26x5
		clr		aAIC26x6

InitAIC26_2:

		mov		#0x8800,W0	; page 1 register 1
		mov		W0,SPI2BUF
ww1:
		btss	IFS1, #SPI2IF
		bra 	ww1
		mov		SPI2BUF,W0
		mov		W0,aAIC26x1
		bclr	IFS1, #SPI2IF

		mov		#0x0000,W0
		mov		W0,SPI2BUF
ww2:
		btss	IFS1, #SPI2IF
		bra 	ww2
		mov		SPI2BUF,W0
		mov		W0,aAIC26x2
		bclr	IFS1, #SPI2IF

		mov		#0x0000,W0
		mov		W0,SPI2BUF
ww3:
		btss	IFS1, #SPI2IF
		bra 	ww3
		mov		SPI2BUF,W0
		mov		W0,aAIC26x3
		bclr	IFS1, #SPI2IF

		mov		#0x0000,W0
		mov		W0,SPI2BUF
ww4:
		btss	IFS1, #SPI2IF
		bra 	ww4
		mov		SPI2BUF,W0
		mov		W0,aAIC26x4
		bclr	IFS1, #SPI2IF

		nop
		nop 

		bra	InitAIC26_2

	return

		
;.............................................................................
; Subroutine: Initialization of W registers to 0x0000
;.............................................................................
_wreg_init:
		CLR W0
		MOV W0, W14
		REPEAT #12
		MOV W0, [++W14]
		CLR W14
		RETURN



	
