; a first selection of audio dsp routines for the dspic\
; - WaveTable1: implemented and tested
; - MTOF2: implemented and tested
; - MTOF: implemented, status unknown
; generally a MTOF2 -> Wavetable -> PWM chirp sounds quite right
; TODO
; - reduce ISR work
; - macro-izing
; - dithering
; - higher precision wavetable for sine? where do those birdies come from?

        .equ __30F2010, 1
        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f2010.inc"
;        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f2010.inc"
		.include "DSPMacros.s"

;..............................................................................
        .global _wreg_init       ;Provide global scope to _wreg_init routine
                                 ;In order to call this routine from a C file,
                                 ;place "wreg_init" in an "extern" declaration
                                 ;in the C file.

        .global __reset          ;The label for the first line of code. 


		.global	__PWMInterrupt
;..............................................................................
;Configuration bits:
;..............................................................................

        config __FOSC, CSW_FSCM_OFF & XT_PLL8    ;Turn off clock switching and
                                            ;fail-safe clock monitoring and
                                            ;use the External Clock as the
                                            ;system clock

        config __FWDT, WDTPSA_512 & WDT_OFF              ;Turn off Watchdog Timer

        config __FBORPOR, PBOR_ON & BORV_27 & PWRT_64 & MCLR_EN & PWMxL_ACT_LO
                                            ;Set Brown-out Reset voltage and
                                            ;and set Power-up Timer to 64msecs

        config __FGS, CODE_PROT_OFF         ;Set Code Protection Off for the 

;.............................................................................
; Constants stored in Program space
;.............................................................................
;	 wavetable data
;.............................................................................
		.section .asciitext, "x"
		.palign 512 ;Align next word stored in
SineTable:
.include "sineTable.s"
ExpTable:
.include "expTable.s"
	.word	0x7FFF
;.............................................................................
; Unintialized storage in data space
;.............................................................................
			.section .bss
Phasor:					.space 4
PhasorStep:				.space 4
result:					.space 2
update:					.space 2
rng:					.space 2
rngcount:				.space 2
dither:					.space 2
midin:					.space 2

count:					.space 2
.text                             ;Start of Code section
__reset:
        MOV #__SP_init, W15       ;Initalize the Stack Pointer
        MOV #__SPLIM_init, W0     ;Initialize the Stack Pointer Limit Register
        MOV W0, SPLIM
        NOP                       ;Add NOP to follow SPLIM initialization
        
        CALL _wreg_init           ;Call _wreg_init subroutine
                                  ;Optionally use RCALL instead of CALL

		clr		Phasor;		LSB
		clr		Phasor+2;	MSB
		
		mov 	#0x4000,W0
		mov		W0,PhasorStep; LSB
		mov 	#0x0004,W0
		mov		W0,PhasorStep+2; MSB

		bclr	TRISE,#0
		bclr	TRISE,#1

		bset 	CORCON,#PSV ; Enable program space visibility

		clr		rng
		bset 	rng,#7
		clr		rngcount
		mov		#0x1000,W0
		mov		W0,midin

		call	InitPWMAudio

loop:
		btss	update,#1
		bra		loop

		bclr	update,#1
		
		PREPCOMPWAVETABLE1 SineTable
		COMPWAVETABLE1 	PhasorStep SineTable Phasor result
		MTOF2	midin PhasorStep
		RNG16	rng


		inc		count
		mov		#0x1F,W0
		and		count
		bra		NZ,loop
		inc		midin

		mov		#0xFFFF,W0
		and		midin
		bra loop


LinearInterp:
; document...
; index format:
;  --------MSB-------- --------LSB--------
;  xxxx xxxi iiii iiif ffff ffff ffff ffxx
; (x = don't care, i = integer part, f = fractional part)
; output: result
		mov 	#psvpage(SineTable),W0
		mov 	W0,PSVPAG
; Step the phasor
		mov		PhasorStep,W0
		add	 	Phasor
		mov	 	PhasorStep+2,W0
		addc 	Phasor+2
; linear interpolation...
		mov 	Phasor+2,W8
		and 	#0x01FE,W8
		mov		#psvoffset(SineTable),W0
		add		W8,W0,W8 
		mov	 	[W8], W4
		add	 	W8,#2,W8
		lsr		Phasor+2,WREG
		rrc		Phasor,WREG
		lsr		W0,#1,W5
		mov		#0x7FFF,W0
		xor	 	W5,W0,W6		
		mpy		W4*W6,A,[W8],W4
		mac		W4*W5,A
		sac.r 	A, #0, W0
		mov		W0,result
	return

InitPWMAudio:

		mov		#0x0200,W0
		mov		W0, PTPER
		
		mov		#0x8000,W0
		mov		W0, PTCON

		mov		#0x0011,W0
		mov		W0, PWMCON1

		bclr	IFS2,#PWMIF
		bset	IEC2,#PWMIE


		bclr 	IPC9,#PWMIP2
		bclr 	IPC9,#PWMIP1
		bset 	IPC9,#PWMIP0

		clr 	DTCON1		; no dead time
		clr 	FLTACON		; no fault
		mov 	#0x0300,W0
		mov		W0, OVDCON

		mov		#0x100,W0
		mov		W0, PDC1
	return


; Midi to frequency 
; actually not frequency but wavetable pointer step
; actually not midi but 0xofff where oo = octave, fff = fraction of octave
; precision: 22steps per semitone
MTOF:
	return



__PWMInterrupt:
		bclr	IFS2,#PWMIF
		push.d	W0 ; Save W0 and W1 on stack


		mov		rng,W0
;		asr		W0,#9,W0
		and		#0x3F,W0
		
		clr		WREG
		add		result,WREG
		asr		W0,#6,W0

;		btss	rng,#1
;		add		#0x01,W0
		
		add 	dither,WREG
		mov		#0x200,W1
		add		W0,W1,W1

		sl		W0,#6,W0
		sub		result,WREG
		lsr		W0,#6,W0
		mov		W0, dither

		clr		dither

		btss	rng,#15
		add		#0x01,W1

;		btss	rng,#15
;		sub		#0x01,W0

; CLIP
;		btsc	W1,#15
;		clr		W1

;		btsc	W1,#9
;		mov		#0x1FF,W1

;		mov		#0x200,W1		
		mov		W1, PDC1

		bset	update,#1		

		pop.d W0 ; Restore W0 and W1
		retfie ; Return from Interrupt Service routine
		
;.............................................................................
; Subroutine: Initialization of W registers to 0x0000
;.............................................................................
_wreg_init:
		CLR W0
		MOV W0, W14
		REPEAT #12
		MOV W0, [++W14]
		CLR W14
		RETURN



	
