; a first selection of audio dsp routines for the dspic\
; - WaveTable1: implemented and tested
; - MTOF2: implemented and tested
; - MTOF: implemented, status unknown
; generally a MTOF2 -> Wavetable -> PWM chirp sounds quite right
; TODO
; - reduce ISR work
; - dithering
; - higher precision wavetable for sine? where do those birdies come from?

        .equ __30F2010, 1
        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f2010.inc"
;        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f2010.inc"
		.include "DSPMacros.s"

;..............................................................................
        .global _wreg_init       ;Provide global scope to _wreg_init routine
                                 ;In order to call this routine from a C file,
                                 ;place "wreg_init" in an "extern" declaration
                                 ;in the C file.

        .global __reset          ;The label for the first line of code. 


		.global	__PWMInterrupt
;..............................................................................
;Configuration bits:
;..............................................................................

        config __FOSC, CSW_FSCM_OFF & XT_PLL8    ;Turn off clock switching and
                                            ;fail-safe clock monitoring and
                                            ;use the External Clock as the
                                            ;system clock

        config __FWDT, WDTPSA_512 & WDT_OFF              ;Turn off Watchdog Timer

        config __FBORPOR, PBOR_ON & BORV_27 & PWRT_64 & MCLR_EN & PWMxL_ACT_LO
                                            ;Set Brown-out Reset voltage and
                                            ;and set Power-up Timer to 64msecs

        config __FGS, CODE_PROT_OFF         ;Set Code Protection Off for the 

;.............................................................................
; Constants stored in Program space
;.............................................................................
;	 wavetable data
;.............................................................................
		.section .asciitext, "x"
		.palign 512 ;Align next word stored in
SineTable:
.include "sineTable.s"
ExpTable:
.include "expTable.s"
	.word	0x7FFF
;.............................................................................
; Unintialized storage in data space
;.............................................................................
			.section .bss
Osc1Pitch:				.space 2
Osc1Phasor:				.space 4
Osc1PhasorStep:			.space 4
Osc1Out:				.space 2

rng1:					.space 2

update:					.space 2
dither:					.space 2
count:					.space 2

Output:					.space 2
OutputPWM:				.space 2

.text                             ;Start of Code section
__reset:
        MOV #__SP_init, W15       ;Initalize the Stack Pointer
        MOV #__SPLIM_init, W0     ;Initialize the Stack Pointer Limit Register
        MOV W0, SPLIM
        NOP                       ;Add NOP to follow SPLIM initialization
        
        CALL _wreg_init           ;Call _wreg_init subroutine
                                  ;Optionally use RCALL instead of CALL

		clr		Osc1Phasor;		LSB
		clr		Osc1Phasor+2;	MSB
		
		mov 	#0x4000,W0
		mov		W0,Osc1PhasorStep; LSB
		mov 	#0x0004,W0
		mov		W0,Osc1PhasorStep+2; MSB

		bclr	TRISE,#0
		bclr	TRISE,#1

		bset 	CORCON,#PSV ; Enable program space visibility

		clr		rng1
		bset 	rng1,#7
		mov		#0x1000,W0
		mov		W0,Osc1Pitch

		call	InitPWMAudio

loop:
		btss	update,#1
		bra		loop

		bclr	update,#1
		
		MTOF2	Osc1Pitch Osc1PhasorStep

		PREPCOMPWAVETABLE1 SineTable
		COMPWAVETABLE1 	Osc1PhasorStep SineTable Osc1Phasor Osc1Out
		RNG16	rng1

		mov		Osc1Out,W4
		mov		#0x3000,W5
		mpy		W4*W5,A
		mov		ACCAH,W0
		mov 	W0,Output
		call	PutOutNonDithered

		inc		count
		mov		#0x1F,W0
		and		count
		bra		NZ,loop
		inc		Osc1Pitch

		bra loop


;---------------------------------------------------------------------------
;	PutOutNonDithered
;	
;	sure but boring
;---------------------------------------------------------------------------
PutOutNonDithered:
		mov		Output,WREG
		asr		W0,#6,W0
		mov		#0x200,W1
		add		W0,W1,W1
; 
;		btss	rng,#15
;		add		#0x01,W1

		mov 	W1,OutputPWM
	return

;---------------------------------------------------------------------------
;	PutOutDithered
;	
;	experimental
;---------------------------------------------------------------------------
PutOutDithered: 
		mov		rng1,W0
;		asr		W0,#9,W0
		and		#0x3F,W0
		
		clr		WREG
		add		Output,WREG
		asr		W0,#6,W0

;		btss	rng,#1
;		add		#0x01,W0
		
		add 	dither,WREG
		mov		#0x200,W1
		add		W0,W1,W1

		sl		W0,#6,W0
		sub		Output,WREG
		lsr		W0,#6,W0
		mov		W0, dither

		clr		dither

		btss	rng1,#15
		add		#0x01,W1

;		btss	rng1,#15
;		sub		#0x01,W0

; CLIP
;		btsc	W1,#15
;		clr		W1

;		btsc	W1,#9
;		mov		#0x1FF,W1

;		mov		#0x200,W1
		mov 	W1,OutputPWM
	return



InitPWMAudio:

		mov		#0x0200,W0
		mov		W0, PTPER
		
		mov		#0x8000,W0
		mov		W0, PTCON

		mov		#0x0011,W0
		mov		W0, PWMCON1

		bclr	IFS2,#PWMIF
		bset	IEC2,#PWMIE


		bclr 	IPC9,#PWMIP2
		bclr 	IPC9,#PWMIP1
		bset 	IPC9,#PWMIP0

		clr 	DTCON1		; no dead time
		clr 	FLTACON		; no fault
		mov 	#0x0300,W0
		mov		W0, OVDCON

		mov		#0x100,W0
		mov		W0, PDC1
	return


; Midi to frequency 
; actually not frequency but wavetable pointer step
; actually not midi but 0xofff where oo = octave, fff = fraction of octave
; precision: 22steps per semitone
MTOF:
	return



__PWMInterrupt:
		bclr	IFS2,#PWMIF
		push	W0 ; Save W0  on stack
		mov		OutputPWM,W0
		mov		W0, PDC1
		bset	update,#1		
		pop 	W0 ; Restore W0
		retfie ; Return from Interrupt Service routine
		
;.............................................................................
; Subroutine: Initialization of W registers to 0x0000
;.............................................................................
_wreg_init:
		CLR W0
		MOV W0, W14
		REPEAT #12
		MOV W0, [++W14]
		CLR W14
		RETURN



	
