; PWM sound output main framework

; a first selection of audio dsp routines for the dspic\
; - WaveTable1: implemented and tested
; - MTOF2: implemented and tested
; - MTOF: implemented, status unknown
; generally a MTOF2 -> Wavetable -> PWM chirp sounds quite right
; TODO
; - buffered pwm output
; - dithering
; - higher precision wavetable for sine? where do those birdies come from?

        .equ __30F2010, 1
        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f2010.inc"
;        .include "C:\Program Files\Microchip\MPLAB ASM30 Suite\Support\inc\p30f2010.inc"
		.include "DSPMacros.s"

;..............................................................................
        .global _wreg_init       ;Provide global scope to _wreg_init routine
                                 ;In order to call this routine from a C file,
                                 ;place "wreg_init" in an "extern" declaration
                                 ;in the C file.

        .global __reset          ;The label for the first line of code. 


		.global	__PWMInterrupt
;..............................................................................
;Configuration bits:
;..............................................................................

        config __FOSC, CSW_FSCM_OFF & XT_PLL8    ;Turn off clock switching and
                                            ;fail-safe clock monitoring and
                                            ;use the External Clock as the
                                            ;system clock

        config __FWDT, WDTPSA_512 & WDT_OFF              ;Turn off Watchdog Timer

        config __FBORPOR, PBOR_ON & BORV_27 & PWRT_64 & MCLR_EN & PWMxL_ACT_LO
                                            ;Set Brown-out Reset voltage and
                                            ;and set Power-up Timer to 64msecs

        config __FGS, CODE_PROT_OFF         ;Set Code Protection Off for the 

;.............................................................................
; Constants stored in Program space
;.............................................................................
;	 wavetable data
;.............................................................................
		.section .asciitext, "x"
		.palign 512 ;Align next word stored in
SineTable:
.include "sineTable.s"
ExpTable:
.include "expTable.s"
	.word	0x7FFF
;.............................................................................
; Unintialized storage in data space
;.............................................................................
			.section .bss
reserve:					.space 64

Osc1Pitch:				.space 2
Osc1Phasor:				.space 4
Osc1PhasorStep:			.space 4
Osc1Out:				.space 2

Osc2Pitch:				.space 2
Osc2Phasor:				.space 4
Osc2PhasorStep:			.space 4
Osc2Out:				.space 2

Osc3Pitch:				.space 2
Osc3Phasor:				.space 4
Osc3PhasorStep:			.space 4
Osc3Out:				.space 2


rng1:					.space 2

update:					.space 2
dither:					.space 2
count:					.space 2

Output:					.space 2
OutputPWM1:				.space 2
OutputPWM2:				.space 2

Osc1Vol:					.space 2

.text                             ;Start of Code section
__reset:
        MOV #__SP_init, W15       ;Initalize the Stack Pointer
        MOV #__SPLIM_init, W0     ;Initialize the Stack Pointer Limit Register
        MOV W0, SPLIM
        NOP                       ;Add NOP to follow SPLIM initialization
        
        CALL _wreg_init           ;Call _wreg_init subroutine
                                  ;Optionally use RCALL instead of CALL

		clr		Osc1Phasor;		LSB
		clr		Osc1Phasor+2;	MSB
		
		clr		Osc2Phasor;		LSB
		clr		Osc2Phasor+2;	MSB

		clr		Osc3Phasor;		LSB
		clr		Osc3Phasor+2;	MSB

		mov 	#0x4000,W0
		mov		W0,Osc1PhasorStep; LSB
		mov 	#0x0004,W0
		mov		W0,Osc1PhasorStep+2; MSB

		mov 	#0x4000,W0
		mov		W0,Osc2PhasorStep; LSB
		mov 	#0x0004,W0
		mov		W0,Osc2PhasorStep+2; MSB


		bclr	TRISE,#0
		bclr	TRISE,#1

		bset 	CORCON,#PSV ; Enable program space visibility

		clr		rng1
		bset 	rng1,#7
		mov		#0xc000,W0
		mov		W0,Osc1Pitch
		mov		#0x1765,W0
		mov		W0,Osc2Pitch
		mov		#0x0010,W0
		mov		W0,Osc3Pitch

		mov		#0x7000,W0
		mov		W0,Osc1Vol

		call	InitPWMAudio

loop:
		btss	update,#1
		bra		loop

		bclr	update,#1
		

;		mov		Osc3Out,W0
;		asr		W0,#7,W0
;		add		Osc2Pitch

;		mov		Osc2Out,W0
;		asr		W0,#6,W0
;		add		Osc1Pitch

		MTOF2	Osc1Pitch Osc1PhasorStep
		MTOF2	Osc2Pitch Osc2PhasorStep
		MTOF2	Osc3Pitch Osc3PhasorStep

		PREPCOMPWAVETABLE1 SineTable
		COMPWAVETABLE1 	Osc1PhasorStep SineTable Osc1Phasor Osc1Out
		COMPWAVETABLE1 	Osc2PhasorStep SineTable Osc2Phasor Osc2Out
		COMPWAVETABLE1 	Osc3PhasorStep SineTable Osc3Phasor Osc3Out
		RNG16	rng1

		mov		Osc1Out,W4
		mov		Osc1Vol,W5
		mpy		W4*W5,A
		mov		ACCAH,W0
		mov 	W0,Output
		call	PutOutNonDithered

;		bra loop

;		mov		#0x3fff,W0
;		and 	Osc3Pitch

;		mov		#0x3fff,W0
;		and 	Osc2Pitch

;		mov		#0x7fff,W0
;		and 	Osc1Pitch

		inc		count
		mov		#0x0F,W0
		and		count
		bra		NZ,loop

		inc		Osc1Pitch

;		dec		Osc2Pitch
;		dec		Osc2Pitch

;		inc 	Osc3Pitch
;		inc 	Osc3Pitch

;		dec 	Osc1Vol
;		mov		#0x7fff,W0
;		and		Osc1Vol

		bra loop


;---------------------------------------------------------------------------
;	PutOutNonDithered
;	
;	sure but boring
;---------------------------------------------------------------------------
PutOutNonDithered:

		nop
		nop
		mov		Output,WREG
		asr		W0,#5,W0
;		mov		#0x200,W1
;		add		W0,W1,W1
; 
;		btss	rng,#15
;		add		#0x01,W1

		bra		N,PutOutNonDitheredN
		
		clr		OutputPWM2
		mov 	W0,OutputPWM1
	return


PutOutNonDitheredN:
		subr		W0,#0,W0
		clr		OutputPWM1
		mov 	W0,OutputPWM2
	return
;---------------------------------------------------------------------------
;	PutOutDithered
;	
;	experimental
;---------------------------------------------------------------------------
PutOutDithered: 
		mov		rng1,W0
;		asr		W0,#9,W0
		and		#0x3F,W0
		
		clr		WREG
		add		Output,WREG
		asr		W0,#6,W0

;		btss	rng,#1
;		add		#0x01,W0
		
		add 	dither,WREG
		mov		#0x200,W1
		add		W0,W1,W1

		sl		W0,#6,W0
		sub		Output,WREG
		lsr		W0,#6,W0
		mov		W0, dither

		clr		dither

		btss	rng1,#15
		add		#0x01,W1

;		btss	rng1,#15
;		sub		#0x01,W0

; CLIP
;		btsc	W1,#15
;		clr		W1

;		btsc	W1,#9
;		mov		#0x1FF,W1

;		mov		#0x200,W1
		mov 	W1,OutputPWM1
	return



InitPWMAudio:

		mov		#0x0200,W0
		mov		W0, PTPER
		
		mov		#0x8000,W0
		mov		W0, PTCON

		mov		#0x0033,W0
		mov		W0, PWMCON1

		bclr	IFS2,#PWMIF
		bset	IEC2,#PWMIE


		bclr 	IPC9,#PWMIP2
		bclr 	IPC9,#PWMIP1
		bset 	IPC9,#PWMIP0

		
		mov		#0x0F,W0	; dead time
		mov		W0,DTCON1
;		clr 	DTCON2		; dead time from unit A
		clr 	FLTACON		; no fault
		mov 	#0x0F00,W0
		mov		W0, OVDCON

		mov		#0x100,W0
		mov		W0, PDC1
		mov		W0, PDC2
	return

__PWMInterrupt:
		bclr	IFS2,#PWMIF
		push	W0 ; Save W0  on stack
		mov		OutputPWM1,W0
		mov		W0, PDC1
		mov		OutputPWM2,W0
		mov		W0, PDC2
		bset	update,#1		
		pop 	W0 ; Restore W0
		retfie ; Return from Interrupt Service routine
		
;.............................................................................
; Subroutine: Initialization of W registers to 0x0000
;.............................................................................
_wreg_init:
		CLR W0
		MOV W0, W14
		REPEAT #12
		MOV W0, [++W14]
		CLR W14
		RETURN



	
