#include <p30fxxxx.h>
#include <stdio.h>              /* Required for printf */
#include <uart.h>
#include "dspicsched.h"
#include "MidiInput.h"
#include "MidiDefs.h"

	#ifdef PRINT
		char str[30]= "t ";
	#endif

void llist_init(llist *ll)
{
	ll->head = 0;
}


void llist_pullhead(llist *ll)
{
	llnode *p = ll->head;
	if (p)
	{
	    void (*fp)(int, int);
		ll->head = p->next;
		fp = p->fun;
		fp(p->time, p->arg);
		p->fun = 0;
	}
}

void llist_insert(llist *ll, unsigned int ttime, void * fun, int arg)
{
	int i;
	// find first free place
	for (i=0;i<LISTSIZE;i++)
	{
		if (ll->storage[i].fun == 0)
			break;
	}
	if (i < LISTSIZE)
	{
		ll->storage[i].time = ttime;
		ll->storage[i].fun = fun;
		ll->storage[i].arg = arg;
		// find place to insert
		llnode *p,*pp;
		p = pp = ll->head;
		if (p)
		{
			if ((int)(p->time - ttime)>0)
			{
				ll->head = &(ll->storage[i]);
				ll->storage[i].next = p;
			}
			else
			{
				while(p)
				{
				if ((int)(p->time - ttime)>0)
						break;
					pp= p;
					p=p->next;
				}
				pp->next = &(ll->storage[i]);
				ll->storage[i].next = p;
			}
		}
		else
		{
			ll->head = &(ll->storage[i]);
			ll->storage[i].next = 0;
		}
	}
	else
		while(1)
			;
}

void llist_print(llist *ll)
{
	#ifdef PRINT

	//	printf("ppp");
		llnode *p;
		p = ll->head;
		while(p)
		{
			sprintf(str,(const char *)"ll.t=%i",(int)p->time);
	//		str ;
			while(BusyUART1());
			putsUART1(str);
			while(BusyUART1());
	//		putsUART1(itoa((int)p->time));
	//		while(BusyUART1());
			
			p=p->next;
		}
		while(BusyUART1());
	#endif
//	printf(".end\r\n");
	putcUART1('\r');
	putcUART1('\n');
	while(BusyUART1());
}

void InitTimer123(void)
{
//	PR1 = 0xFFFF;
//	IFS0bits.T1IF = 0;
//	IEC0bits.T1IE = 1;
//	IPC0bits.T1IP = 7;	
//	T1CONbits.TON = 1;	
//	T1CONbits.TCKPS = 0;//1;
	PR2 = 0x5FFF;
	PR3 = 0xFFFF;
//	T2CONbits.T32 = 1;
	T2CONbits.TCKPS = 0;
	T2CONbits.TON = 0;	
	T2CONbits.TCKPS = 0;
	TMR2 = 0x4FF0;
	TMR3 = 0xFFFF;	
	// enable interrupt
	IFS0bits.T2IF = 0;
	IEC0bits.T2IE = 1;
	IPC1bits.T2IP = 12;	
;	T2CONbits.TON = 1;	
}

llist a;
volatile int time = 0;





/*
void __attribute__((__interrupt__)) _T1Interrupt( void )
{
//	long time = 0;
	IFS0bits.T1IF = 0;
}
*/
void _ISR _T2Interrupt( void )
{
	time++;
	IFS0bits.T2IF = 0;
//	TMR2 = 0x9000;	
}



int notmain(void)
{
	#ifdef PRINT
	int U1MODEvalue, U1STAvalue;
		CloseUART1();         //Turn off UART1
		ConfigIntUART1(
	    UART_RX_INT_DIS & 
	    UART_RX_INT_PR7 & 
	    UART_TX_INT_DIS & 
	    UART_TX_INT_PR2);  //config UART1 Rx and Tx interrupts
		//baudvalue=(((CLOCK/BAUD)/16)-1);
		//baudvalue = 95; // 9600 baud @ ~15MIPS
		U1MODEvalue =     UART_EN&
	              UART_ALTRX_ALTTX&
	              UART_NO_PAR_8BIT&
	              UART_1STOPBIT;
		U1STAvalue = UART_TX_ENABLE; 
		OpenUART1(U1MODEvalue, U1STAvalue, 1);
		//(UART_EN,0xFF,10);
		//	OpenUART2(UART_EN,0,10);
	
		putcUART1('\r');
		putcUART1('\n');
		while(BusyUART1());
		putcUART1('*');
		putcUART1('*');
		while(BusyUART1());
		putcUART1('\r');
		putcUART1('\n');
		while(BusyUART1());
	#endif
	InitTimer123();
/*
	llist_init(&a);
	llist_insert(&a, 100, &fun_metro);
	llist_print(&a);
	llist_insert(&a, 200, &tfun);
	llist_print(&a);
	llist_insert(&a, 300, &tfun);
	llist_print(&a);
	llist_insert(&a, 150, &fun_metro);
	llist_print(&a);
	llist_insert(&a, 50, &tfun);
	llist_print(&a);
	llist_insert(&a, 60, &tfun);
	llist_print(&a);
	llist_insert(&a, 160, &tfun);
	llist_print(&a);
*/
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//	llist_pullhead(&a);
//	llist_print(&a);
//
	while(1) 
	{
		if (a.head && ((time - a.head->time) >= 0))
		{
			llist_pullhead(&a);
			llist_print(&a);
		}

	}
	return 0;	
}
