; PWM sound output main framework

;; successsor of theremin
; doing
; -strip project
; 
        .equ __30F2010, 1
        .include "p30f2010.inc"
;		.include "DSPMacros.s"
		.include "DSPMacros2.s"

;..............................................................................
        .global _not_main     
		.global	__PWMInterrupt
		.global	__T1Interrupt

		.global		_inAmp1
		.global		_inPitch1
		.global		_outAmp1
		.global		_outPitch1

		.global		_coefPitch1
		.global		_coefAmp1
		.global		_LFO1Amp
		.global		_LFO2Amp
		.global		_LFO1Pitch
		.global		_LFO2Pitch

		.global		_Env1Counter
		.global		_Env1State

		.global		_Env1Attack
		.global		_Env1Hold
		.global		_Env1Decay
		.global		_Env1Sustain
		.global		_Env1Release
;.............................................................................
; Constants stored in Program space
;.............................................................................
;	 wavetable data
;.............................................................................
		.section .asciitext, "x"
		.palign 512 ;Align next word stored in
SineTable:
.include "sineTable.s"
ExpTable:
.include "expTable.s"
	.word	0x7FFF

;.............................................................................
; Unintialized storage in data space
;.............................................................................
			.section .bss
;reserve:					.space 64
.equ __ICD2RAM,1
; ---- DSP Stuff
Osc1Pitch:				.space 2
Osc1Phasor:				.space 4
Osc1PhasorStep:			.space 4
Osc1Out:				.space 2

_LFO1Pitch:				.space 2
LFO1Phasor:				.space 4
LFO1PhasorStep:			.space 4
LFO1Out:				.space 2
_LFO1Amp:				.space 2

_LFO2Pitch:				.space 2
LFO2Phasor:				.space 4
LFO2PhasorStep:			.space 4
LFO2Out:				.space 2
_LFO2Amp:				.space 2

_inPitch1:				.space 2
_outPitch1:				.space 4
_coefPitch1:			.space 2
lpTemp1:				.space 4

_inAmp1:				.space 2
_outAmp1:				.space 4
_coefAmp1:				.space 2
lpTemp2:				.space 4

_Env1Counter:			.space 2
_Env1State:				.space 2

_Env1Attack:			.space 2
_Env1Hold:				.space 2
_Env1Decay:				.space 2
_Env1Sustain:			.space 2
_Env1Release:			.space 2

; ---- DAC stuff

rng1:					.space 2
dither:					.space 2

Output:					.space 2
OutputPWM1:				.space 2
OutputPWM2:				.space 2

.align 2 ;Align next word stored in
OutputBufRdPtr:			.space 2
OutputBufWrPtr:			.space 2


; --- block operation...
.equ __OUTBUFSIZE,8 ; 8 samples, ping-pong

.align 64 ;Align next word stored in
OutputBuf:				.space 32
.align 2 ;Align next word stored in
.section .ydata
TVec1:					.space 16
.section .ydata
TVec2:					.space 16
.section .ydata
TVec3:					.space 16
.section .ydata
TDVec1:					.space 32


.text   ;Start of Code section

;.............................................................................
; BOOT code
;.............................................................................

_not_main:
		clr		Osc1Phasor;		LSB
		clr		Osc1Phasor+2;	MSB
		
		bclr	LATE,#0
		bclr	LATE,#1
		bclr	LATE,#2
		bclr	LATE,#3
		bclr	TRISE,#0
		bclr	TRISE,#1
		bclr	TRISE,#2
		bclr	TRISE,#3

		bclr	TRISE,#5
		bset	LATE,#5
		bset	LATD,#0

		bset 	TRISD,#0	;	pushbutton
		bclr 	TRISD,#1	;	LED

		bset 	CORCON,#PSV ; Enable program space visibility

		clr		rng1
		bset 	rng1,#7
		mov		#0x1000,W0
		mov		W0,Osc1Pitch
		mov		W0,_inPitch1
		mov		W0,_outPitch1

		mov		#0x0080,W0
		mov		W0,_coefPitch1

		mov		#0x0020,W0
		mov		W0,_coefAmp1

		mov		#0x0000,W0
		mov		W0,_outAmp1
		mov		W0,_inAmp1

		mov		#0x050,W0
		mov		W0,_LFO2Amp

		mov		#0x2000,W0
		mov		W0,_LFO2Pitch
		call	InitPWMAudio
		nop

	return


InitPWMAudio:
		mov		#OutputBuf,W0
		mov 	W0,OutputBufRdPtr
		add		#8,W0
		mov 	W0,OutputBufWrPtr

		mov		#0x00F0,W0 ; 100kHz at 24MHz fcyc
;		mov		#0x0180,W0
		mov		W0, PTPER
		
		mov		#0x8000,W0
		mov		W0, PTCON

		mov		#0x0033,W0
		mov		W0, PWMCON1

		bclr	IFS2,#PWMIF
		bset	IEC2,#PWMIE

		bset 	IPC9,#PWMIP2 ; priority 6
		bset 	IPC9,#PWMIP1
		bclr 	IPC9,#PWMIP0
		
		mov		#0x00,W0	; dead time
		mov		W0,DTCON1
		clr 	FLTACON		; no fault
		mov 	#0x0F00,W0
		mov		W0, OVDCON

		mov		#0x100,W0
		mov		W0, PDC1
		mov		W0, PDC2


		; enable timer 0 interrupts (fake...)
		bclr		IFS0,#T1IF;
		bset		IEC0,#T1IE;

		bset		IPC0,#T1IP0 ; priority 5
		bclr		IPC0,#T1IP1
		bset		IPC0,#T1IP2

	return

__PWMInterrupt:
		push.s ; fast context save

		mov		OutputBufRdPtr,W0;
		mov		[W0++],W2
;		mov 	W1,Output
		bclr	W0,#5;
		mov		W0,OutputBufRdPtr;
		and		#0x0F,W0
		bra		NZ,_skip

		mov		OutputBufRdPtr,W0;
		add		#0x010,W0
		bclr	W0,#5;
		mov 	W0,OutputBufWrPtr
		bset	IFS0,#T1IF; 		
_skip:
		mov  	W2,W0
		add		dither,WREG
		asr		W2,#5,W1
		sl		W1,#5,W0
		sub		WREG2,WREG
		add		dither		
		add		W1,#0,W0				
		bra		N,IPutOutDitheredN		
		clr		PDC2
		mov 	W0,PDC1
		bclr	IFS2,#PWMIF

		pop.s ; fast context restore
	retfie ; Return from Interrupt Service routine


IPutOutDitheredN:
		subr	W0,#0,W0
		clr		PDC1
		mov 	W0,PDC2
		bclr	IFS2,#PWMIF

		pop.s ; fast context restore
	retfie ; Return from Interrupt Service routine



; 1263 / 1928 cycles... (65%)
; 1225 / 1928 cycles... now
; 1168 / 1928 cycles... now
; 1137 a 1132 / 1928 cycles... optimized wavetable (58% load)
; 1085 cycles... (56%...)
; 911 cycles... (had lfo 2x)
; 1001 cycles... (completed tremolo fx)

__T1Interrupt:
		push.d	W0 ; Save W0,W1  on stack
		push.d	W2 ; Save W2,W3  on stack
		push.d	W4 ; Save W4,W5  on stack
		push.d	W6 ; Save W5,W7  on stack
		push.d	W8 ; Save W8.W9  on stack
		push.d	W10 ; Save W10.W11  on stack
		bclr		IFS0,#T1IF;
		mov 	#psvpage(ExpTable),W0
		mov 	W0,PSVPAG

		RNG16	rng1

; envelope here
		dec		_Env1Counter
		bra		NZ, _contEnv
		mov		_Env1State,W0
		sub		W0,#0,W1
		bra		Z,Env1State0
		bra		NZ, _contEnv
Env1State0:
		mov		_Env1Decay,W0
		mov		W0,_coefAmp1
		mov		_Env1Sustain,W0
		mov		W0,_inAmp1
		inc		_Env1State
;		bra		_contEnv
; </env>
_contEnv:
;<dsp>
		PREPMTOF2
		PREP2MTOF2 LFO1PhasorStep
		MTOF2	_LFO1Pitch 
		PREP2MTOF2 LFO2PhasorStep
		MTOF2	_LFO2Pitch 

		COMPWAVETABLE1_B8_C LFO1PhasorStep SineTable LFO1Phasor TVec3

		COMPWAVETABLE1_B8_C LFO2PhasorStep SineTable LFO2Phasor TVec2

		K_TO_A_SMOOTH_B8 _inPitch1, _coefPitch1, TVec1, _outPitch1

		RNG16	rng1

		mov		#TVec1,W9
		mov		#TVec2,W10
		mov		#TVec1,W11
		mov		_LFO2Amp,W4
		mov		[W9++],W5
		mov		[W10++],W6
		do 	#7,_pch_loop
			mpy		W4*W6,A ;,[W10]+=2,W6;
			lac		W5,B
			add		A
			mov		[W9++],W5
			mov		[W10++],W6
_pch_loop: 	sac  A,[W11++]

		MTOF2_B8 TVec1 TDVec1
		COMPWAVETABLE1_B8 TDVec1 SineTable Osc1Phasor TVec2
		K_TO_A_SMOOTH_B8 _inAmp1, _coefAmp1, TVec1, _outAmp1

		mov		#TVec1,W9  ; env
		mov		#TVec2,W10 ; osc
		mov		#TVec3,W11 ; lfo
		mov		OutputBufWrPtr,W7;
;		mov		[W10++],W6

		mov		#0x8000,W8
		mov		_LFO1Amp,W1

		do 	#7,_amp_loop
			mov		[W11++],W0
			mul.ss	W0,W1,W2
			add		W3,W8,W0
			mov		[W9++],W2
			mul.us		W0,W2,W2
			mov		W3,W4
			mov		[W10++],W6
			mpy		W4*W6,A;
;			mov     ACCAH,W4
;			mac		W4*W5,A;
_amp_loop: sac  A,[W7++]
		

		RNG16	rng1

;		COMPWAVETABLE1_B8_C LFO1PhasorStep SineTable LFO1Phasor TVec1

		pop.d	W10 ; 
		pop.d	W8 ; 
		pop.d	W6 ; 
		pop.d	W4 ; 
		pop.d	W2 ; restore W2,W3  
		pop.d	W0 ; 
	retfie ; Return from Interrupt Service routine

